const Fuse = require('fuse-native')
const Errors = require('../../shared/Errors')
const Message = require('../../shared/Message')
const connector = require('../connector')

module.exports = exports = function (path, name, cb) {
    connector.send(
        Message.route('fs.xattr.list')
            .data({ path, name })
            .expect_response(msg => {
                if ( msg.error() ) {
                    return Errors.toCallback(cb, msg.error())
                }

                const { names } = msg.data()
                return process.nextTick(cb, 0, names)
            })
    )
}
